Given a non-negative integer n, count all numbers with unique digits, X, where 0≤x < 10n.
Example:
Given n = 2, return 91. (The answer should is the total numbers in the range of 0≤x <, excluding [11,22,33,44,55,66,77,88,99]
)
Hint:
- A Direct backtracking approach.
- Backtracking should contains three states which is (the current number, number of steps to get, and a bitmask which represent which number is marked as visited so far in the current number). Start with State (0,0,0) and count all valid number till we reach number of steps equals to 10n.
- This problem can also is solved using a dynamic programming approach and some knowledge of combinatorics.
- Let f (k) = Count of numbers with the unique digits with length equals K.
- F (1) = ten, ..., f (k) = 9 * 9 * 8 * ... (9-k + 2) [The first factor is 9 because a number cannot start with 0].
Credits:
Special thanks to @memoryless for adding this problem and creating all test cases.
Thinking of solving problems
Following the hint. Let f (N) = Count of number with unique digits of length n.
F (1) = 10. (0, 1, 2, 3, ....., 9)
F (2) = 9 * 9. Because for each number I from 1, ..., 9, we can pick J to form a 2-digit number ij and there is 9 numbers that is Diffe Rent from-I for J-choose from.
F (3) = f (2) * 8 = 9 * 9 * 8. Because for each number with the unique digits of length 2, say ij, we can pick K to form a 3 digit number Ijk and there is 8 Numbers that is different from, and J for K to choose.
Similarly f (4) = f (3) *7=9*9*8*7....
...
F (10) = 9 * 9 * 8 * 7 * 6 * ... * 1
F (one) = 0 = f (a) = f (13) ....
Any number with length > couldn ' t is unique digits number.
The problem is asking for numbers from 0 to 10^n. Hence return F (1) + F (2) +. + f (N)
As @4acreg suggests, there is only different ans. You can create a lookup table for it. This problem was O (1) in essence.
Public intCountnumberswithuniquedigits (intN) {if(n = = 0)return1; intres = 10; intUniquedigits = 9; intAvailablenumber = 9; while(n--> 1 && availablenumber > 0) {uniquedigits= Uniquedigits *Availablenumber; Res+=uniquedigits; Availablenumber--; } returnRes; }
Reference
Https://discuss.leetcode.com/topic/47983/java-dp-o-1-solution/2
Count Numbers with Unique Digits